"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_redux_1 = require("react-redux");
var universal_connector_factory_1 = require("../component/connector/universal-connector.factory");
var application_action_builder_1 = require("../component/application/application-action.builder");
var universal_container_1 = require("../component/base/universal.container");
/**
 * @stable - 23.04.2018
 * @param {IContainerClassEntity} applicationContainer
 * @param {IUniversalContainerEntity} initialProps
 * @returns {IContainerClassEntity}
 */
exports.makeBootstrapApp = function (applicationContainer, initialProps) {
    var Component = universal_connector_factory_1.universalConnectorFactory(applicationContainer, function (state) { return (__assign({}, state.application)); });
    return /** @class */ (function (_super) {
        __extends(class_1, _super);
        function class_1(props) {
            var _this = _super.call(this, props) || this;
            // We must dispatch the init action necessarily before the application instantiating
            // because of async App Ready State & Flux architecture
            _this.appStore.dispatch({ type: application_action_builder_1.ApplicationActionBuilder.buildInitActionType() });
            return _this;
        }
        class_1.prototype.render = function () {
            return (React.createElement(react_redux_1.Provider, { store: this.appStore },
                React.createElement(Component, __assign({}, initialProps))));
        };
        return class_1;
    }(universal_container_1.UniversalContainer));
};
//# sourceMappingURL=universal-bootstrap-app.factory.js.map