import Vue from 'vue';
import { Store } from 'redux';
import { ApplicationTranslatorT } from '../../translation';
import { AnyT, IKeyValue, IEntity } from '../../definitions.interface';
import { IVueApplicationStoreEntity, IVueContainer } from '../../vue-entities-definitions.interface';
export declare class VueBaseContainer extends Vue implements IVueContainer {
    section$: string;
    store$: Store<IVueApplicationStoreEntity>;
    protected t: ApplicationTranslatorT;
    /**
     * @stable [21.10.2018]
     * @returns {IVueApplicationStoreEntity}
     */
    readonly state$: IVueApplicationStoreEntity;
    /**
     * @stable [18.11.2018]
     * @param {string} type
     * @param {TChanges} data
     */
    dispatch<TChanges = IKeyValue>(type: string, data?: TChanges): void;
    /**
     * @stable [13.11.2018]
     * @param {TChanges} changes
     */
    dispatchFormChanges<TChanges = IKeyValue>(changes: TChanges): void;
    /**
     * @stable [18.11.2018]
     * @param {string} fieldName
     * @param {AnyT} fieldValue
     */
    dispatchFormChange(fieldName: string, fieldValue?: AnyT): void;
    /**
     * @stable [19.11.2018]
     */
    dispatchFormSubmit(): void;
    /**
     * @stable [18.11.2018]
     * @param {string} dictionary
     * @param {TData} data
     */
    dispatchLoadDictionary<TData = IKeyValue>(dictionary: string, data?: TData): void;
    /**
     * @stable [21.10.2018]
     * @param {string} type
     * @param {AnyT} data
     */
    dispatchCustomType<TData = IKeyValue>(type: string, data?: TData): void;
    /**
     * @stable [25.10.2018]
     */
    protected navigateToBack(): void;
    /**
     * @stable [25.10.2018]
     */
    protected dispatchListCreate(): void;
    /**
     * @stable [08.12.2018]
     * @param {IEntity} entity
     */
    protected dispatchListSelect(entity: IEntity): void;
    /**
     * @stable [25.10.2018]
     * @param {TPath0} path
     * @param {TState0} state
     */
    protected navigate<TPath0, TState0>(path: TPath0, state?: TState0): void;
    /**
     * @stable [17.11.2018]
     * @returns {VueBaseContainer}
     */
    protected getSelf(): VueBaseContainer;
}
