"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var native_base_1 = require("native-base");
var native_base_2 = require("native-base");
var util_1 = require("../../util");
var universal_component_1 = require("../base/universal.component");
var button_support_1 = require("./button.support");
var RnButton = /** @class */ (function (_super) {
    __extends(RnButton, _super);
    function RnButton() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable - 19.04.2018
     * @returns {JSX.Element}
     */
    RnButton.prototype.render = function () {
        var _this = this;
        var props = this.props;
        var buttonText = button_support_1.getButtonText(props, this.settings.messages);
        var icon = button_support_1.getButtonIcon(props, 'time', 'information-circle');
        return (React.createElement(native_base_2.Button, { rounded: props.rounded, disabled: button_support_1.isButtonDisabled(props), bordered: props.bordered, style: props.style, block: props.block, small: props.small, success: props.success, large: props.large, iconLeft: props.iconLeft, transparent: props.transparent, onPress: props.onPress },
            util_1.orNull(icon, function () { return React.createElement(native_base_2.Icon, { name: icon, style: props.iconStyle }); }),
            util_1.orNull(buttonText, function () { return (React.createElement(native_base_1.Text, { style: props.textStyle }, _this.t(buttonText))); }),
            props.children));
    };
    RnButton.defaultProps = {
        iconLeft: true,
    };
    return RnButton;
}(universal_component_1.UniversalComponent));
exports.RnButton = RnButton;
//# sourceMappingURL=rn-button.component.js.map