"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var ts_smart_logger_1 = require("ts-smart-logger");
var util_1 = require("../../util");
var base_1 = require("../base");
var chip_1 = require("../chip");
var ChipsFilter = /** @class */ (function (_super) {
    __extends(ChipsFilter, _super);
    /**
     * @stable [26.08.2018]
     * @param {IChipsFilterProps} props
     */
    function ChipsFilter(props) {
        var _this = _super.call(this, props) || this;
        _this.onRemoveFilter = _this.onRemoveFilter.bind(_this);
        return _this;
    }
    /**
     * @stable [26.08.2018]
     * @returns {JSX.Element}
     */
    ChipsFilter.prototype.render = function () {
        var _this = this;
        var props = this.props;
        var changes = props.filterForm.changes;
        var changedFieldsNames = Object.keys(changes);
        if (changedFieldsNames.length === 0) {
            return null;
        }
        return (React.createElement("div", { className: util_1.toClassName('rac-chips-filter-wrapper', props.className) }, changedFieldsNames.map(function (changedFieldName) {
            var fieldConfig = props.fieldsConfigurations[changedFieldName];
            if (R.isNil(fieldConfig)) {
                ChipsFilter.logger.warn("[$ChipsFilter][render] The config is not defined to the field name " + changedFieldName);
                return null;
            }
            var fieldConfigAsString = fieldConfig;
            var fieldConfigAsObject = fieldConfig;
            var str = util_1.isString(fieldConfigAsString) ? fieldConfigAsString : fieldConfigAsObject.label;
            if (R.isNil(str) || R.isEmpty(str)) {
                ChipsFilter.logger.warn("[$ChipsFilter][render] The config is not defined to the field name " + changedFieldName);
                return null;
            }
            return (React.createElement(chip_1.Chip, { key: "chips-filter-item-key-" + changedFieldName, onClick: function () { return _this.onRemoveFilter(changedFieldName); } }, str));
        })));
    };
    /**
     * @stable [26.08.2018]
     * @param {string} filterFieldName
     */
    ChipsFilter.prototype.onRemoveFilter = function (filterFieldName) {
        var props = this.props;
        if (props.onRemove) {
            props.onRemove(filterFieldName);
        }
    };
    ChipsFilter.logger = ts_smart_logger_1.LoggerFactory.makeLogger('ChipsFilter');
    return ChipsFilter;
}(base_1.BaseComponent));
exports.ChipsFilter = ChipsFilter;
//# sourceMappingURL=chips-filter.component.js.map