"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var vue_property_decorator_1 = require("vue-property-decorator");
var util_1 = require("../../../util");
var vue_index_1 = require("../../base/vue-index");
var vue_field_interface_1 = require("./vue-field.interface");
var VueField = /** @class */ (function (_super) {
    __extends(VueField, _super);
    /**
     * @stable [17.11.2018]
     */
    function VueField() {
        var _this = _super.call(this) || this;
        _this.getInputBindings = _this.getInputBindings.bind(_this);
        _this.getInputListeners = _this.getInputListeners.bind(_this);
        _this.getFieldClassName = _this.getFieldClassName.bind(_this);
        _this.isInputWrapperFull = _this.isInputWrapperFull.bind(_this);
        _this.getInputWrapperClassName = _this.getInputWrapperClassName.bind(_this);
        _this.isFieldFull = _this.isFieldFull.bind(_this);
        return _this;
    }
    /**
     * @stable [26.10.2018]
     */
    VueField.prototype.mounted = function () {
        if (this.autoFocus) {
            this.setFocus();
        }
    };
    /**
     * @stable [21.10.2018]
     * @param {VueCreateElementFactoryT} createElement
     * @returns {VueNodeT}
     */
    VueField.prototype.render = function (createElement) {
        var options = {
            computed: this.getTemplateComputed(),
            methods: this.getTemplateMethods(),
            template: "\n        <vue-flex-layout :row=\"true\"\n                         :alignItemsCenter=\"true\"\n                         :full=\"isFieldFull()\"\n                         :class=\"getFieldClassName()\">\n          <vue-flex-layout ref=\"inputWrapper\"\n                           :class=\"getInputWrapperClassName()\"\n                           :full=\"isInputWrapperFull()\">\n            <input ref=\"self\"\n                   v-bind=\"getInputBindings()\"\n                   v-on=\"getInputListeners()\"\n                   v-model:value=\"value$\"/>\n            " + this.getInputAttachmentTemplate() + "\n          </vue-flex-layout>\n          " + this.getLabelTemplate() + "\n          " + this.getFieldAttachmentTemplate() + "\n        </vue-flex-layout>\n      ",
        };
        return createElement(options);
    };
    /**
     * @stable [17.11.2018]
     * @returns {Partial<HTMLInputElement>}
     */
    VueField.prototype.getInputBindings = function () {
        var _this = this;
        return util_1.defValuesFilter(__assign({ type: this.type, placeholder: util_1.ifNilReturnDefault(this.placeholder, function () { return _this.t(_this.placeholder); }, util_1.orUndef(this.hasFloatLabel(), function () { return _this.t(_this.label); })) }, { class: this.getInputClassName() }));
    };
    /**
     * @stable [17.11.2018]
     * @returns {string}
     */
    VueField.prototype.getFieldClassName = function () {
        return util_1.toClassName('vue-field', util_1.calc(this.className, this.getDisplayValue()), this.hasValue() ? 'vue-field-filled' : 'vue-field-not-filled', this.hasFloatLabel() ? 'vue-field-float-labeled' : 'vue-field-not-float-labeled');
    };
    /**
     * @stable [17.11.2018]
     * @returns {IVueFieldInputListenersEntity}
     */
    VueField.prototype.getInputListeners = function () {
        return {};
    };
    /**
     * @stable [17.11.2018]
     * @returns {boolean}
     */
    VueField.prototype.isInputWrapperFull = function () {
        return true;
    };
    /**
     * @stable [17.11.2018]
     * @returns {boolean}
     */
    VueField.prototype.isFieldFull = function () {
        return this.full;
    };
    /**
     * @stable [27.11.2018]
     * @returns {string}
     */
    VueField.prototype.getInputWrapperClassName = function () {
        return util_1.toClassName('vue-field-input-wrapper', this.type === 'hidden' && 'rac-display-none');
    };
    /**
     * @stable [17.11.2018]
     * @returns {AnyT}
     */
    VueField.prototype.getValue = function () {
        return util_1.isDef(this.bindStore) ? this.bindStore[this.name] : this.value;
    };
    /**
     * @stable [21.10.2018]
     * @param {AnyT} newValue
     */
    VueField.prototype.onChange = function (newValue) {
        var data = this.getData();
        if (!R.isNil(data) && this.canSetDataDisplayValueOnManualInputChange(newValue)) {
            data.displayValue = newValue;
        }
        if (this.isContainerBound()) {
            this.bindContainer.dispatchFormChange(this.name, newValue);
        }
        this.$emit(vue_field_interface_1.VUE_FIELD_CHANGE_EVENT, newValue);
    };
    /**
     * @stable [28.11.2018]
     * @param newValue
     * @param {AnyT} context
     */
    VueField.prototype.onChangeManually = function (newValue, context) {
        this.onChange(newValue);
    };
    /**
     * @stable [20.12.2018]
     * @returns {TState}
     */
    VueField.prototype.getInitialData$ = function () {
        return {
            displayValue: null,
        };
    };
    /**
     * @stable [20.12.2018]
     * @param {AnyT} newValue
     * @returns {boolean}
     */
    VueField.prototype.canSetDataDisplayValueOnManualInputChange = function (newValue) {
        return false;
    };
    /**
     * @stable [17.11.2018]
     * @returns {string}
     */
    VueField.prototype.getInputClassName = function () {
        return 'vue-field-input';
    };
    /**
     * @stable [21.10.2018]
     * @returns {string}
     */
    VueField.prototype.getFieldAttachmentTemplate = function () {
        return '';
    };
    /**
     * @stable [18.11.2018]
     * @returns {string}
     */
    VueField.prototype.getInputAttachmentTemplate = function () {
        return '';
    };
    /**
     * @stable [22.10.2018]
     * @returns {string}
     */
    VueField.prototype.getLabelTemplate = function () {
        var _this = this;
        return util_1.orEmpty(!R.isNil(this.label), function () { return "<label class=\"" + util_1.toClassName('vue-field-label', _this.floatLabel && 'vue-field-float-label') + " \">\n                " + _this.t(_this.label) + "\n             </label>"; });
    };
    /**
     * @stable [24.11.2018]
     * @returns {boolean}
     */
    VueField.prototype.hasValue = function () {
        var value = this.getValue();
        return !R.isNil(value) && !R.equals(value, this.getEmptyValue());
    };
    /**
     * @stable [10.12.2018]
     * @returns {AnyT}
     */
    VueField.prototype.getEmptyValue = function () {
        return '';
    };
    /**
     * @stable [10.12.2018]
     * @returns {boolean}
     */
    VueField.prototype.hasFloatLabel = function () {
        return !R.isNil(this.label) && this.floatLabel;
    };
    /**
     * @stable [26.10.2018]
     * @returns {IVueFieldTemplateComputedEntity}
     */
    VueField.prototype.getTemplateComputed = function () {
        var _this = this;
        return {
            value$: {
                get: function () { return _this.getInputDisplayValue(); },
                set: function (newValue) { return _this.onChange(newValue); },
            },
        };
    };
    /**
     * @stable [17.11.2018]
     * @returns {AnyT}
     */
    VueField.prototype.getDisplayValue = function () {
        var _this = this;
        var data = this.getData();
        var value = this.getValue();
        var displayValue = util_1.ifNotNilReturnValue(data, function () { return data.displayValue; });
        var displayNameValue;
        return util_1.orDefault(R.isNil(displayValue), function () { return util_1.orDefault(displayNameValue = _this.fromStore(_this.displayName), displayNameValue, value); }, displayValue);
    };
    /**
     * @stable [21.12.2018]
     * @returns {AnyT}
     */
    VueField.prototype.getInputDisplayValue = function () {
        var value = this.getValue();
        var displayValue = this.getDisplayValue();
        return this.isFieldChangedManually(value)
            ? displayValue
            : (this.useLocalization ? this.t(displayValue) : displayValue);
    };
    /**
     * @stable [21.12.2018]
     * @param {AnyT} newValue
     * @returns {boolean}
     */
    VueField.prototype.isFieldChangedManually = function (newValue) {
        return true;
    };
    Object.defineProperty(VueField.prototype, "inputEl", {
        /**
         * @stable [26.10.2018]
         * @returns {HTMLInputElement}
         */
        get: function () {
            return this.getChildrenRefs().self;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VueField.prototype, "inputWrapperEl", {
        /**
         * @stable [17.11.2018]
         * @returns {HTMLInputElement}
         */
        get: function () {
            return this.getChildrenRefs().inputWrapper.$el;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [26.10.2018]
     */
    VueField.prototype.setFocus = function () {
        this.inputEl.focus();
    };
    /**
     * @stable [22.12.2018]
     * @returns {TMethods}
     */
    VueField.prototype.getTemplateMethods = function () {
        return {
            getInputWrapperClassName: this.getInputWrapperClassName,
            getFieldClassName: this.getFieldClassName,
            getInputBindings: this.getInputBindings,
            getInputListeners: this.getInputListeners,
            isInputWrapperFull: this.isInputWrapperFull,
            isFieldFull: this.isFieldFull,
        };
    };
    /**
     * @stable [20.12.2018]
     * @param {string} fieldName
     * @returns {AnyT}
     */
    VueField.prototype.fromStore = function (fieldName) {
        var _this = this;
        return util_1.ifNotNilReturnValue(this.bindStore, function () { return _this.bindStore[fieldName]; });
    };
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], VueField.prototype, "value", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueField.prototype, "full", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueField.prototype, "useLocalization", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueField.prototype, "label", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueField.prototype, "displayName", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueField.prototype, "name", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueField.prototype, "placeholder", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueField.prototype, "type", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueField.prototype, "floatLabel", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueField.prototype, "icon", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueField.prototype, "autoFocus", void 0);
    return VueField;
}(vue_index_1.VueBaseComponent));
exports.VueField = VueField;
//# sourceMappingURL=vue-field.component.js.map