"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var vue_property_decorator_1 = require("vue-property-decorator");
var util_1 = require("../../../util");
var vue_index_1 = require("../field/vue-index");
var vue_index_2 = require("../multifield/vue-index");
var VueBaseFileField = /** @class */ (function (_super) {
    __extends(VueBaseFileField, _super);
    /**
     * @stable [27.11.2018]
     */
    function VueBaseFileField() {
        var _this = _super.call(this) || this;
        _this.multiFieldPlugin = new vue_index_2.MultiFieldPlugin(_this);
        _this.cachedFiles = new Map();
        _this.onFileChange = _this.onFileChange.bind(_this);
        _this.onFilesSelect = _this.onFilesSelect.bind(_this);
        _this.getViewerBindings = _this.getViewerBindings.bind(_this);
        _this.getViewerListeners = _this.getViewerListeners.bind(_this);
        _this.getViewerComponent = _this.getViewerComponent.bind(_this);
        _this.getDefaultDndMessage = _this.getDefaultDndMessage.bind(_this);
        _this.getPlaceholder = _this.getPlaceholder.bind(_this);
        _this.getFiles = _this.getFiles.bind(_this);
        return _this;
    }
    /**
     * @stable [25.11.2018]
     * @returns {string}
     */
    VueBaseFileField.prototype.getFieldClassName = function () {
        return _super.prototype.getFieldClassName.call(this) + " vue-file-field";
    };
    /**
     * @stable [16.12.2018]
     * @param {File[]} files
     * @returns {string[]}
     */
    VueBaseFileField.prototype.onFilesSelect = function (files) {
        var _this = this;
        return Array.from(files).map(function (file) {
            var url = _this.toFileUrl(file);
            _this.addFile(file, url); // TODO Need to many files handling
            return url;
        });
    };
    /**
     * @stable [22.12.2018]
     * @param {number} index
     * @returns {string}
     */
    VueBaseFileField.prototype.getDefaultDndMessage = function (index) {
        var _this = this;
        return util_1.coalesce(this.defaultDndMessage, util_1.ifNotNilReturnValue(this.defaultDndMessageFactory, function () { return _this.defaultDndMessageFactory(index); }), this.settings.messages.dndMessage);
    };
    /**
     * [<Placeholder: optional> + <Default DnD message>]
     *
     * @stable [22.12.2018]
     * @param {number} index
     * @returns {string}
     */
    VueBaseFileField.prototype.getPlaceholder = function (index) {
        return util_1.isFn(this.placeholderFactory)
            ? this.placeholderFactory(index)
            : this.t(this.placeholder);
    };
    /**
     * @stable [20.12.2018]
     * @returns {IEntity[]}
     */
    VueBaseFileField.prototype.getFiles = function () {
        return [];
    };
    /**
     * @stable [22.12.2018]
     * @param {MultiItemEntityT} entityOrEntityId
     * @param {number} index
     * @returns {IVueBaseFileViewerProps}
     */
    VueBaseFileField.prototype.getViewerBindings = function (entityOrEntityId, index) {
        var _this = this;
        var props = __assign({}, this.viewerProps, { placeholder: this.getPlaceholder(index), className: this.getAttachmentContentClassName(index) });
        var multiItemEntity = entityOrEntityId;
        var className = function () { return util_1.toClassName(util_1.calc(_this.clsFactory, multiItemEntity), util_1.calc(props.className)); };
        if (util_1.isPrimitive(entityOrEntityId)) {
            // In case of a single field which receives only entity id
            return __assign({}, props, { src: this.getDisplayValue() || entityOrEntityId, fileName: this.getFileName() });
        }
        else if (multiItemEntity.newEntity) {
            var relationId_1 = multiItemEntity.id;
            return util_1.defValuesFilter(__assign({}, props, { src: relationId_1, fileName: util_1.orUndef(this.cachedFiles.has(relationId_1), function () { return _this.cachedFiles.get(relationId_1).name; }), className: className() }));
        }
        return __assign({}, props, { src: Reflect.get(multiItemEntity, this.displayName), entity: multiItemEntity, className: className() });
    };
    /**
     * @stable [16.12.2018]
     * @param {IMultiItemEntity} fileEntity
     * @param {number} index
     * @returns {IVueViewerListenersEntity<File>}
     */
    VueBaseFileField.prototype.getViewerListeners = function (fileEntity, index) {
        var _this = this;
        return {
            change: function (file) { return _this.onFileChange(fileEntity, file); },
            remove: function () { return _this.removeFile(fileEntity); },
        };
    };
    /**
     * @stable [21.12.2018]
     * @param {File} file
     * @param {number} index
     * @returns {string}
     */
    VueBaseFileField.prototype.getViewerComponent = function (file, index) {
        return this.viewer;
    };
    /**
     * @stable [06.01.2019]
     * @param {number} index
     * @returns {string}
     */
    VueBaseFileField.prototype.getAttachmentContentClassName = function (index) {
        return util_1.toClassName('vue-field-attachment-content', this.getPlaceholder(index) && ' vue-field-attachment-content-with-placeholder');
    };
    /**
     * @stable [17.11.2018]
     * @returns {string}
     */
    VueBaseFileField.prototype.getInputClassName = function () {
        return _super.prototype.getInputClassName.call(this) + " rac-flex-full";
    };
    /**
     * @stable [09.12.2018]
     * @returns {string}
     */
    VueBaseFileField.prototype.getFieldAttachmentTemplate = function () {
        return ("<div class=\"vue-field-attachment-wrapper\">\n          <template v-for=\"(file, index) in getFiles()\">\n            <component v-if=\"file\"\n                       :is=\"getViewerComponent(file, index)\"\n                       v-on=\"getViewerListeners(file, index)\"\n                       v-bind=\"getViewerBindings(file, index)\"/>\n            <vue-flex-layout v-if=\"!file\"\n                             :row=\"true\"\n                             :class=\"getAttachmentContentClassName(index)\">\n                <vue-flex-layout v-if=\"getPlaceholder(index)\"\n                                :justifyContentCenter=\"true\"\n                                :class=\"'vue-field-attachment-placeholder vue-field-attachment-placeholder-' + index\">\n                    {{getPlaceholder(index)}}\n                </vue-flex-layout>\n                <vue-flex-layout :class=\"'vue-field-attachment-dnd-message vue-field-attachment-dnd-message-' + index\"\n                                 :full=\"!getPlaceholder(index)\">\n                    <vue-dnd :defaultMessage=\"getDefaultDndMessage(index)\"\n                             @select=\"onFilesSelect($event)\"/>\n                </vue-flex-layout>\n            </vue-flex-layout>\n          </template>\n       </div>");
    };
    /**
     * @stable [16.12.2018]
     * @param {IMultiItemEntity} fileEntity
     * @param {File} file
     */
    VueBaseFileField.prototype.onFileChange = function (fileEntity, file) {
        var _this = this;
        var newFileUrl = this.toFileUrl(file);
        if (fileEntity.newEntity) {
            this.removeFile(fileEntity);
            this.$nextTick(function () { return _this.addFile(file, newFileUrl); });
        }
        else {
            this.multiFieldPlugin.onEditItem({ id: fileEntity.id, name: this.displayName, value: newFileUrl });
        }
    };
    /**
     * @stable [10.12.2018]
     * @returns {TMethods}
     */
    VueBaseFileField.prototype.getTemplateMethods = function () {
        return __assign({}, _super.prototype.getTemplateMethods.call(this), { onFilesSelect: this.onFilesSelect, getFiles: this.getFiles, getDefaultDndMessage: this.getDefaultDndMessage, getAttachmentContentClassName: this.getAttachmentContentClassName, getPlaceholder: this.getPlaceholder, getViewerComponent: this.getViewerComponent, getViewerListeners: this.getViewerListeners, getViewerBindings: this.getViewerBindings });
    };
    VueBaseFileField.prototype.getFileFormat = function () {
        var _this = this;
        var fileFormatValue;
        return util_1.orDefault(util_1.isDef(this.bindStore) && !R.isNil(fileFormatValue = this.bindStore[this.displayFileFormat]), fileFormatValue, function () { return _this.getValue(); });
    };
    /**
     * @stable [10.12.2018]
     * @param {File} file
     * @returns {string}
     */
    VueBaseFileField.prototype.toFileUrl = function (file) {
        var newFileUrl = URL.createObjectURL(file);
        this.cachedFiles.set(newFileUrl, file);
        return newFileUrl;
    };
    /**
     * @stable [28.11.2018]
     * @param {string} fileUrl
     */
    VueBaseFileField.prototype.destroyFileUrl = function (fileUrl) {
        this.cachedFiles.delete(fileUrl);
        URL.revokeObjectURL(fileUrl);
    };
    /**
     * @stable [22.12.2018]
     * @param {File} file
     * @param {string} fileUrl
     */
    VueBaseFileField.prototype.addFile = function (file, fileUrl) {
        var rawData = {
            id: fileUrl,
            newEntity: true,
            type: file.type,
            name: file.name,
        };
        this.multiFieldPlugin.onAddItem({ id: fileUrl, rawData: rawData });
    };
    /**
     * @stable [28.11.2018]
     * @param {IMultiItemEntity} fileEntity
     */
    VueBaseFileField.prototype.removeFile = function (fileEntity) {
        var fileId = fileEntity;
        var multiItemEntity = fileEntity;
        // TODO refactoring
        if (util_1.isPrimitive(fileEntity)) {
            this.multiFieldPlugin.onDeleteItem({ id: fileId });
            this.destroyFileUrl(fileId);
        }
        else {
            this.multiFieldPlugin.onDeleteItem(multiItemEntity);
            this.destroyFileUrl(multiItemEntity.id);
        }
    };
    VueBaseFileField.prototype.getFileName = function () {
        var _this = this;
        var fileNameValue;
        return util_1.orDefault(util_1.isDef(this.bindStore) && !R.isNil(fileNameValue = this.bindStore[this.displayFileName]), fileNameValue, function () { return _this.getValue(); });
    };
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueBaseFileField.prototype, "displayFileName", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueBaseFileField.prototype, "displayFileFormat", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Function)
    ], VueBaseFileField.prototype, "placeholderFactory", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: function () { return 1; } }),
        __metadata("design:type", Number)
    ], VueBaseFileField.prototype, "maxFiles", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", String)
    ], VueBaseFileField.prototype, "defaultDndMessage", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Function)
    ], VueBaseFileField.prototype, "defaultDndMessageFactory", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: function () { return 'vue-file-viewer'; } }),
        __metadata("design:type", String)
    ], VueBaseFileField.prototype, "viewer", void 0);
    __decorate([
        vue_property_decorator_1.Prop({ default: function () { return 'hidden'; } }),
        __metadata("design:type", String)
    ], VueBaseFileField.prototype, "type", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Function)
    ], VueBaseFileField.prototype, "clsFactory", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Object)
    ], VueBaseFileField.prototype, "viewerProps", void 0);
    return VueBaseFileField;
}(vue_index_1.VueField));
exports.VueBaseFileField = VueBaseFileField;
//# sourceMappingURL=vue-base-filefield.component.js.map