"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var util_1 = require("../../../util");
var base_grid_column_component_1 = require("../base-column/base-grid-column.component");
var GridColumn = /** @class */ (function (_super) {
    __extends(GridColumn, _super);
    /**
     * @stable [10.09.2018]
     * @param {IGridColumnProps} props
     */
    function GridColumn(props) {
        var _this = _super.call(this, props) || this;
        _this.onColumnClick = _this.onColumnClick.bind(_this);
        return _this;
    }
    /**
     * @stable [10.09.2018]
     * @returns {JSX.Element}
     */
    GridColumn.prototype.render = function () {
        var _this = this;
        var props = this.props;
        return util_1.orNull(props.columnRendered !== false, function () { return (React.createElement("td", { style: _this.getStyle({ width: props.columnWidth }), colSpan: util_1.nvl(props.columnColSpan, props.colSpan), className: _this.getClassName(props.actioned && 'rac-grid-actioned-column', util_1.calc(props.columnClassName, props)), title: util_1.orUndef(!R.isNil(props.columnTitle) || util_1.isPrimitive(props.children), function () { return R.isNil(props.columnTitle) ? props.children : props.columnTitle; }), onClick: util_1.orUndef(util_1.isFn(props.onColumnClick), function () { return _this.onColumnClick; }) }, _this.getColumnContentElement('rac-overflow-ellipsis'))); });
    };
    /**
     * @stable [10.09.2018]
     * @param {IBasicEvent} event
     */
    GridColumn.prototype.onColumnClick = function (event) {
        var props = this.props;
        props.onColumnClick({ event: event, props: props });
    };
    return GridColumn;
}(base_grid_column_component_1.BaseGridColumn));
exports.GridColumn = GridColumn;
//# sourceMappingURL=grid-column.component.js.map