"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var util_1 = require("../../../util");
var base_1 = require("../../base");
var keyboard_interface_1 = require("../keyboard.interface");
var configurations_definitions_interface_1 = require("../../../configurations-definitions.interface");
var KeyboardKey = /** @class */ (function (_super) {
    __extends(KeyboardKey, _super);
    function KeyboardKey() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [08.05.2018]
     * @returns {JSX.Element}
     */
    KeyboardKey.prototype.render = function () {
        var _this = this;
        var props = this.props;
        var keyAsString = props.value;
        var keyAsObject = props.value;
        var value = util_1.isString(keyAsString)
            ? (props.useUppercase
                ? keyAsString.toUpperCase()
                : keyAsString)
            : (keyAsObject.type === configurations_definitions_interface_1.KeyboardKeyEnum.UPPERCASE
                ? (props.useUppercase ? keyboard_interface_1.KEYBOARD_SPECIAL_KEYS.LOWERCASE : keyAsObject.value)
                : keyAsObject.value);
        return (React.createElement("div", { ref: 'self', style: keyAsObject && keyAsObject.width ? { width: (keyAsObject && keyAsObject.width) + "px" } : {}, className: util_1.toClassName('rac-keyboard-key', "rac-keyboard-key-" + value, 'rac-flex', 'rac-flex-center', keyAsObject && keyAsObject.className, this.uiFactory.rippleSurface), onClick: function (event) { return _this.onClick(event); } }, value));
    };
    /**
     * @stable [08.05.2018]
     * @param {IBasicEvent} e
     */
    KeyboardKey.prototype.onClick = function (e) {
        this.stopEvent(e);
        this.props.onSelect(this.props.value);
    };
    return KeyboardKey;
}(base_1.BaseComponent));
exports.KeyboardKey = KeyboardKey;
//# sourceMappingURL=keyboard-key.component.js.map