"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var default_layout_view_builder_1 = require("./default-layout-view.builder");
var configurations_definitions_interface_1 = require("../../../configurations-definitions.interface");
var universal_layout_builder_1 = require("./universal-layout.builder");
describe('layout.builder', function () {
    it('test1', function () {
        function PseudoElement(name, value) {
            var _a;
            this.props = (_a = {}, _a[name] = value, _a);
        }
        var layoutBuilder = new universal_layout_builder_1.UniversalLayoutBuilder(new default_layout_view_builder_1.DefaultLayoutViewBuilder());
        var layout = layoutBuilder.build({
            children: [
                new PseudoElement('p1', 'v1'),
                {
                    layout: configurations_definitions_interface_1.LayoutBuilderTypeEnum.HORIZONTAL,
                    children: [
                        new PseudoElement('p2', 'v2'),
                        {
                            factor: configurations_definitions_interface_1.LayoutBuilderFactorEnum.FACTOR_2,
                            children: [
                                new PseudoElement('p4', 'v4'),
                                new PseudoElement('p5', 'v5')
                            ],
                        },
                        new PseudoElement('p3', 'v3')
                    ],
                }
            ],
        });
        expect(layout).toEqual({
            rows: [
                new PseudoElement('p1', 'v1'),
                {
                    columns: [
                        new PseudoElement('p2', 'v2'),
                        { separator: null },
                        {
                            factor: configurations_definitions_interface_1.LayoutBuilderFactorEnum.FACTOR_2,
                            rows: [
                                new PseudoElement('p4', 'v4'),
                                new PseudoElement('p5', 'v5')
                            ],
                        },
                        { separator: null },
                        new PseudoElement('p3', 'v3')
                    ],
                }
            ],
        });
    });
});
//# sourceMappingURL=layout.builder.spec.js.map