"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var R = require("ramda");
var di_1 = require("../../di");
var PersistentScrollPlugin = /** @class */ (function () {
    /**
     * @stable [13.12.2018]
     * @param {IUniversalScrollableComponent} component
     */
    function PersistentScrollPlugin(component) {
        this.component = component;
    }
    /**
     * @stable [18.12.2018]
     */
    PersistentScrollPlugin.prototype.componentDidMount = function () {
        this.scrollToUniversalSelectedElement();
    };
    /**
     * @stable [18.12.2018]
     */
    PersistentScrollPlugin.prototype.componentDidUpdate = function () {
        if (this.top) {
            this.domAccessor.setScrollTop(this.component.getSelf(), this.top);
        }
        if (this.left) {
            this.domAccessor.setScrollLeft(this.component.getSelf(), this.left);
        }
    };
    /**
     * @stable [18.12.2018]
     */
    PersistentScrollPlugin.prototype.getSnapshotBeforeUpdate = function () {
        this.top = this.domAccessor.getScrollTop(this.component.getSelf());
        this.left = this.domAccessor.getScrollLeft(this.component.getSelf());
        return null;
    };
    /**
     * @stable [18.12.2018]
     */
    PersistentScrollPlugin.prototype.scrollToUniversalSelectedElement = function () {
        var self = this.component.getSelf();
        var selectedElement = this.domAccessor.findUniversalSelectedElement(self);
        if (!R.isNil(selectedElement)) {
            this.domAccessor.scrollTo(selectedElement, self);
        }
    };
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.DomAccessor),
        __metadata("design:type", Object)
    ], PersistentScrollPlugin.prototype, "domAccessor", void 0);
    return PersistentScrollPlugin;
}());
exports.PersistentScrollPlugin = PersistentScrollPlugin;
//# sourceMappingURL=persistent-scroll.plugin.js.map