import { IApplicationTransport, ITransportRequestParamsEntity } from './transport.interface';
import { IEntity } from '../definitions.interface';
import { IEditableApiEntity } from '../entities-definitions.interface';
import { IApplicationSettings } from '../settings';
export declare class BaseTransport {
    protected transport: IApplicationTransport;
    protected settings: IApplicationSettings;
    /**
     * @stable [11.09.2018]
     * @param {ITransportRequestParamsEntity} params
     */
    protected downloadAnchoredFile(params: ITransportRequestParamsEntity): void;
    /**
     * @stable - 12.04.2018
     * @param {IEditableApiEntity<TEntity extends IEntity>} entity
     * @returns {Promise<TEntity extends IEntity>}
     */
    protected doSaveEntity<TEntity extends IEntity>(entity: IEditableApiEntity<TEntity>): Promise<TEntity>;
}
